# DeleteSubnet

## 1. API Description

This API is used to delete a subnet.

{% hint style="info" %} <mark style="color:blue;">**Note**</mark>

* <mark style="color:blue;">Operations on subnets with instances in it are not supported. You can use</mark> [<mark style="color:purple;">`DescribeSubnets`</mark>](https://docs.console.zenlayer.com/api-reference/compute/zvm/network/describesubnets) <mark style="color:blue;">to query the status of the subnet.</mark>
* <mark style="color:blue;">Only operations on subnets in the status of</mark> <mark style="color:blue;">`Available`</mark> <mark style="color:blue;">or</mark> <mark style="color:blue;">`Failed`</mark> <mark style="color:blue;">are supported.</mark>
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type   | Description |
| -------------- | -------- | ------ | ----------- |
| subnetId       | Yes      | String | Subnet ID.  |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                              |
| -------------- | ------ | -------------------------------------------------------------------------------------------------------- |
| requestId      | String | The unique request ID, which is returned for each request. RequestId is required for locating a problem. |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Delete a subnet.**

```json
POST /api/v2/vm HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: DeleteSubnet
<Common Request Params>

Request:
{
  "subnetId": "your-subnet-id"
}

Response:
{
  "requestId": "TA8D35A96-1BCC-4D10-96CB-CCB7600C1428",
  "response": {
    "requestId": "TA8D35A96-1BCC-4D10-96CB-CCB7600C1428"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](https://docs.console.zenlayer.com/api-reference/api-introduction/toolkit/api-sdk) to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](https://docs.console.zenlayer.com/api-reference/api-introduction/instruction/commonerrorcode).​

| HTTP Status Code | Error Code                                                  | Description                                                     |
| ---------------- | ----------------------------------------------------------- | --------------------------------------------------------------- |
| 500              | DELETE\_SUBNET\_FAILED                                      | Deleting failed.                                                |
| 404              | INVALID\_SUBNET\_NOT\_FOUND                                 | Subnet does not exist.                                          |
| 400              | UNSUPPORTED\_OPERATION\_SUBNET\_HAS\_INSTANCE               | Operations on subnets with instances in it are not supported.   |
| 400              | UNSUPPORTED\_OPERATION\_SUBNET\_HAS\_PRE\_PRODUCT\_INSTANCE | Instance is being created.                                      |
| 400              | UNSUPPORTED\_OPERATION\_SUBNET\_STATUS\_ERROR               | Operations on the subnet with current status are not supported. |
| 400              | OPERATION\_DENIED\_UNSUPPORTED\_SUBNET                      | Operations on the specified subnet are not supported.           |
